<template>
  <aside class="sidebar">
    <section class="sidebar__inner">
      <section class="sidebar__header">
        <div class="left">
          <md-icon>library_music</md-icon>
          <span>Playlists</span>
        </div>
        <div class="right" v-if="isContentLoaded">
          <md-button class="md-icon-button" @click="prevChart" v-bind:disabled="currentPlaylistsPage == 1">
            <md-icon>keyboard_arrow_left</md-icon>
          </md-button>
          <md-button class="md-icon-button" @click="nextChart" v-bind:disabled="!hasPlaylistsNextPage || state.loadingMore">
            <md-icon>keyboard_arrow_right</md-icon>
          </md-button>
        </div>
      </section>
      <section class="charts">
        <section class="chart__list" v-if="!isContentLoaded">
          <sidebar-playlist-placeholder v-for="(item, index) in Array.from({ length: 8 })" v-bind:key="index"></sidebar-playlist-placeholder>
        </section>
        <section class="chart__list" v-if="isContentLoaded">
          <section class="chart" v-for="playlist in displayedPlaylists" v-bind:key="playlist.id" v-on:click="navigateTo('playlist', playlist.id)">
            <section class="chart__cover" v-bind:style="{ backgroundImage: 'url(' + playlist.picture + ')' }"></section>
            <section class="chart__meta">
              <section class="chart__title">{{playlist.title}}</section>
              <section class="chart__user">by {{playlist.user.name}}</section>
              <section class="chart__user">{{playlist.nb_tracks}} tracks</section>
            </section>
          </section>
        </section>
      </section>
      <section class="sidebar__header" v-if="isContentLoaded">
        <div class="left">
          <md-icon>mic</md-icon>
          <span>Artists</span>
        </div>
        <div class="right">
          <md-button class="md-icon-button" @click="prevArtist" v-bind:disabled="currentArtistsPage == 1">
            <md-icon>keyboard_arrow_left</md-icon>
          </md-button>
          <md-button class="md-icon-button" @click="nextArtist" v-bind:disabled="!hasArtistsNextPage || state.loadingMore">
            <md-icon>keyboard_arrow_right</md-icon>
          </md-button>
        </div>
      </section>
      <section class="artists" v-if="isContentLoaded">
        <section class="artist__list">
          <section class="artist" v-for="artist in displayedArtists" v-bind:key="artist.id" v-on:click="navigateTo('artist', artist.id)">
            <section class="artist__cover" v-bind:style="{ backgroundImage: 'url(' + artist.picture + ')' }"></section>
            <section class="artist__title">{{artist.name}}</section>
          </section>
        </section>
      </section>
      <section class="sidebar__header" v-if="isContentLoaded">
        <div class="left">
          <md-icon>headset</md-icon>
          <span>Genres</span>
        </div>
      </section>
      <section class="sidebar__genres">
        <section class="sidebar__genre__list" v-if="isContentLoaded">
          <section class="sidebar__genre" v-for="genre in genres" v-bind:key="genre.id" v-on:click="navigateTo('genre', genre.id);$store.dispatch('setCurrentPlaylistName', genre.name)">
            <section class="sidebar__genre__title">{{genre.name}}</section>
          </section>
        </section>
      </section>
    </section>
  </aside>
</template>

<script>
import Vue from 'vue';
import Component from 'vue-class-component';
import { State } from 'vuex-class';
import SidebarPlaylistPlaceholder from './SidebarPlaylistPlaceholder';

@Component({
  components: {
    'sidebar-playlist-placeholder': SidebarPlaylistPlaceholder,
  },
})
export default class Sidebar extends Vue {
  MAX_PLAYLISTS_COUNT_ON_PAGE = 8;
  MAX_ARTISTS_COUNT_ON_PAGE = 12;
  MAX_GENRES_COUNT_ON_PAGE = 9;
  currentPlaylistsPage = 1;
  currentArtistsPage = 1;
  currentTime = 0;

  @State(state => state.sidebar)
  state;

  @State(state => state.genres)
  genresState;

  get isContentLoaded() {
    return this.genres.length && this.state.playlists.length;
  }

  get displayedPlaylists() {
    if (!this.state.playlists || !this.state.playlists.length) {
      return [];
    }
    const startIndex = (this.currentPlaylistsPage - 1) * this.MAX_PLAYLISTS_COUNT_ON_PAGE;
    const endIndex = startIndex + this.MAX_PLAYLISTS_COUNT_ON_PAGE;
    return this.state.playlists.slice(startIndex, endIndex);
  }

  get hasPlaylistsNextPage() {
    const result = this.MAX_PLAYLISTS_COUNT_ON_PAGE * (this.currentPlaylistsPage + 1) < this.state.playlists.length;
    if (!result) {
      this.loadMore();
    }
    return result;
  }

  get displayedArtists() {
    if (!this.state.artists || !this.state.artists.length) {
      return [];
    }
    const startIndex = (this.currentArtistsPage - 1) * this.MAX_ARTISTS_COUNT_ON_PAGE;
    const endIndex = startIndex + this.MAX_ARTISTS_COUNT_ON_PAGE;
    return this.state.artists.slice(startIndex, endIndex);
  }

  get hasArtistsNextPage() {
    const result = (this.currentArtistsPage + 1) * this.MAX_ARTISTS_COUNT_ON_PAGE < this.state.artists.length;
    if (!result) {
      this.loadMore();
    }
    return result;
  }

  get genres() {
    if (!this.genresState.genres.length) {
      return [];
    }
    return this.genresState.genres.slice(1, this.MAX_GENRES_COUNT_ON_PAGE + 1);
  }

  loadMore() {
    if (!this.state.loadingMore && this.state.hasMore) {
      this.$store.dispatch('sidebarLoadMore');
    }
  }

  nextChart() {
    this.currentPlaylistsPage += 1;
  }

  prevChart() {
    if (this.currentPlaylistsPage <= 1) {
      return;
    }
    this.currentPlaylistsPage -= 1;
  }

  nextArtist() {
    this.currentArtistsPage += 1;
  }
  prevArtist() {
    if (this.currentArtistsPage <= 1) {
      return;
    }
    this.currentArtistsPage -= 1;
  }

  navigateTo(type, id) {
    this.$router.push({
      name: 'play',
      params: { type, id },
    });
  }

  mounted() {
    if (!this.state.playlists.length) {
      this.$store.dispatch('fetchDataForSidebar', {
        perPage: 60,
        page: 1,
      });
    }
    if (!this.genres || !this.genres.length) {
      this.$store.dispatch('fetchAllGenreData');
    }
  }
}
</script>

<style lang="stylus" scoped>

@keyframes boxShadowLoading {
  0% {
    opacity 0.2  
  }
  50% {
    opacity 1  
  }
  100% {
    opacity 0.2  
  }
}

.sidebar
  min-width 0
  height 100%
  padding 14px 16px 18px 16px
  display flex
  flex-direction column
  flex 5

  &__inner
    width 100%
    position sticky
    top calc(-1300px + 100vh)
    display flex
    flex-direction column
    transform translateZ(0)

    .md-button[disabled]
      opacity: .3 !important

  &__header
    height 46px
    max-height 46px
    margin-bottom 12px
    display flex
    justify-content space-between
    align-items center 
    font-size 14px
    font-weight 900

    .md-icon
      color #565c69 !important

    .left
      display flex
      align-items center
      color rgb(86,92,105)
      font-weight 900
      text-transform uppercase

      .md-icon
        margin-right 8px
        font-size 16px

    .right
      color #999
      font-size 10px
      text-transform uppercase

  &__genre__list
    margin-bottom 14px
    display flex
    flex-wrap wrap
    flex-direction row

  &__genre
    width 154px
    max-width 154px
    min-height 45px
    position relative
    margin-right 10px
    margin-bottom 8px
    padding 0 12px
    display flex
    flex-direction row
    justify-content center
    align-items center
    background-color #1c212c
    border-radius 0
    overflow hidden
    cursor pointer
    transition all .35s ease-in-out
    &:hover
      opacity .6

    &__title
      position relative
      max-width 100%
      display block
      z-index 10
      color #fff
      font-size 13px
      font-family 'Encode Sans', sans-serif
      font-weight 900
      white-space nowrap
      text-overflow ellipsis
      overflow hidden

  .chart__list
    margin-bottom 14px
    display flex
    flex-wrap wrap
    flex-direction row

  .chart
    width 220px
    min-width 220px
    max-width 220px
    min-height 60px
    margin-right 10px
    margin-bottom 16px
    position relative
    display flex
    flex-direction row
    overflow hidden
    cursor pointer
    transition opacity .12s ease
    &:hover
      opacity .8

    &__cover
      width 78px
      min-width 78px
      max-width 78px
      height 78px
      min-height 78px
      max-width 78px
      background-size cover
      background-color #1c212c
      border-radius 4px
      transition all .3s ease-in-out

    &__meta
      padding-left 12px

    &__title
      max-width 100%
      padding-bottom 2px
      color #eee
      font-size 14px
      font-weight bold

    &__user
      color rgb(86,92,105)
      font-size 12px
      font-weight bold
      line-height 1.3

  .artist__list
    display flex
    flex-wrap wrap
    flex-direction row

  .artist
    width 120px
    max-width 120px
    min-height 60px
    position relative
    margin-right 0
    margin-bottom 16px
    display flex
    flex-direction column
    align-items center
    overflow hidden
    cursor pointer
    transition opacity .12s ease
    &:hover
      opacity .9

    &__cover
      width 76px
      min-width 76px
      max-width 76px
      height 76px
      min-height 76px
      max-height 76px
      background-size cover
      border-radius 50%

    &__title
      max-width 100%
      padding-top 12px
      padding-bottom 2px
      color #eee
      font-size 12px
      font-weight bold
      white-space nowrap
      text-overflow ellipsis
      overflow hidden
</style>

